// Georgui Rekouts, Nov 1994
// modal.cpp - Implementation of the modal dialog class

#include "DlgTest.h"

// ---------------------------------------------------------------
TMyModal::TMyModal(TWindow *Parent, TResId ResId) :
  TDialog(Parent, ResId), TWindow(Parent, 0)
{
  Outliner = new TTSCTreeList(this, IDC_LISTBOX1);
}

// ---------------------------------------------------------------
TMyModal::~TMyModal()
{
  delete Outliner;
}

// ---------------------------------------------------------------
void TMyModal::SetupWindow()
{
  TDialog::SetupWindow();
  // add additional code here
  TNodeView *view = Outliner->AddView(new TStringView);
  view->SetOpenBitmap (new TBitmap(*GetApplication(), "DLGOPEN"));
  view->SetCloseBitmap(new TBitmap(*GetApplication(), "DLGCLOSE"));
  view->SetNodeBitmap (new TBitmap(*GetApplication(), "DLGNODE"));

  TNode *nodeRoot = Outliner->GetNodeRoot();
  TNode *node = Outliner->AddNode(nodeRoot, new TStringNode("Parent 1"), view);
  Outliner->AddNode(node, new TStringNode("child 1"), view);
  Outliner->AddNode(node, new TStringNode("child 2"), view);
  node = Outliner->AddNode(nodeRoot, new TStringNode("Parent 2"), view);
  TNode *subNode = Outliner->AddNode(node, new TStringNode("SubParent 1"), view);
  Outliner->AddNode(subNode, new TStringNode("child 3"), view);
  Outliner->AddNode(subNode, new TStringNode("child 4"), view);
  Outliner->AddNode(node, new TStringNode("child 5"), view);
  Outliner->Update();
}

DEFINE_RESPONSE_TABLE1(TMyModal, TDialog)
  EV_LBN_DBLCLK(IDC_LISTBOX1, EvDblClk),
END_RESPONSE_TABLE;


void TMyModal::EvDblClk()
{
  
}
