// Georgui Rekouts, Nov 1994
// node.cpp Base class for all nodes to be inserted to TOutliner
// Always associated with a viewer to display its data

#include "treelist.h"

//------------------------------------------------ Node constructor
TNode::TNode( void *nodeData )
{
	NodeData  = nodeData;
	Parent    = NULL;
	ChildList = NULL;
	View      = NULL;
	BIsOpen   = FALSE;
}

//------------------------------------------------ Node destructor
TNode::~TNode()
{
	FreeNodeList(GetChildList());
}

//---------------------------------------- Set Parent
void TNode::SetParent(TNode *parent)
{
	Parent = parent;
}

//---------------------------------------- Set Child List
void TNode::SetChildList(TNodeList *childList)
{
	if( ChildList )
	{
		FreeNodeList(ChildList);
	}
	ChildList = childList;
}


//------------------------------------------------ Free Node List
void FreeNodeList(TNodeList *nodeList)
{
	if ( nodeList )
	{
		TNodeListIterator iter(*nodeList);
		while( iter )
		{
			delete iter.Current();
			iter++;
		}
		delete nodeList;
	}
}

//--------------- needed operators for TListImp
TNode::TNode(const TNode &copyNode)
{
  ChildList = NULL;
  *this = copyNode;
}

TNode& TNode::operator = (const TNode &copyNode)
{
  SetChildList(copyNode.GetChildList());
  SetParent(copyNode.GetParent());
  SetOpen(copyNode.IsOpen());
  return *this;
}

int TNode::operator == (const TNode &) const
{
  return FALSE;
}

